<?php

namespace Drupal\layout_library_st\Form;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Language\LanguageInterface;
use Drupal\layout_library\Form\LayoutBuilderForm as CoreLayoutBuilderForm;

/**
 * The overriden Layout Builder form.
 */
class LayoutBuilderForm extends CoreLayoutBuilderForm {

  /**
   * {@inheritDoc}
   */
  public function save(array $form, FormStateInterface $form_state) {
    $urlLanguage = \Drupal::languageManager()->getCurrentLanguage(LanguageInterface::TYPE_URL);

    if ($urlLanguage->isDefault()) {
      $result = $this->sectionStorage->save();
    }
    else {
      $layoutConfiguration = $this->sectionStorage->getLayoutOverrides($urlLanguage->getId());
      $layout = $this->getEntity();

      $configId = $layout->getConfigDependencyName();
      $configOverride = \Drupal::languageManager()->getLanguageConfigOverride($urlLanguage->getId(), $configId);
      $configOverride->setData(['layout' => $layoutConfiguration]);
      $configOverride->save();
      $result = SAVED_UPDATED;
    }

    $this->layoutTempstoreRepository->delete($this->sectionStorage);
    $this->messenger()->addMessage($this->t('The layout has been saved.'));
    $form_state->setRedirectUrl($this->sectionStorage->getRedirectUrl());

    return $result;
  }

}